| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | List of all members
ITHistSvc Class Referenceabstract

`#include <GaudiKernel/ITHistSvc.h>`

Inheritance diagram for ITHistSvc:
[legend]
Collaboration diagram for ITHistSvc:
[legend]

## Public Member Functions
| DeclareInterfaceID (ITHistSvc, 3, 0)
| InterfaceID. More...
virtual | ~ITHistSvc ()=default
| virtual destructor More...
Functions to manage ROOT histograms of any kind
virtual StatusCode | regHist (const std::string &name)=0
| Register a new ROOT histogram TH*X with a name. More...
virtual StatusCode | regHist (const std::string &name, std::unique_ptr< TH1 > hist)=0
| Register an existing ROOT histogram TH*X with name and moved unique_ptr. More...
virtual StatusCode | regHist (const std::string &name, std::unique_ptr< TH1 > hist, TH1 *hist_ptr)=0
| Register an existing ROOT histogram TH*X with name and moved unique_ptr. More...
virtual StatusCode | regHist (const std::string &name, TH1 *)=0
virtual StatusCode | getHist (const std::string &name, TH1 *&, size_t index=0) const =0
| Return histogram with given name as TH1*, THistSvcMT still owns object. More...
virtual StatusCode | getHist (const std::string &name, TH2 *&, size_t index=0) const =0
| Return histogram with given name as TH2*, THistSvcMT still owns object. More...
virtual StatusCode | getHist (const std::string &name, TH3 *&, size_t index=0) const =0
| Return histogram with given name as TH3*, THistSvcMT still owns object. More...
Functions to manage TTrees
virtual StatusCode | regTree (const std::string &name)=0
| Register a new TTree with a given name. More...
virtual StatusCode | regTree (const std::string &name, std::unique_ptr< TTree >)=0
| Register an existing TTree with a given name and moved unique_ptr. More...
virtual StatusCode | regTree (const std::string &name, TTree *)=0
virtual StatusCode | getTree (const std::string &name, TTree *&) const =0
| Return TTree with given name. More...
Functions to manage TGraphs
virtual StatusCode | regGraph (const std::string &name)=0
| Register a new TGraph with a given name. More...
virtual StatusCode | regGraph (const std::string &name, std::unique_ptr< TGraph >)=0
| Register an existing TGraph with a given name and moved unique_ptr. More...
virtual StatusCode | regGraph (const std::string &name, TGraph *)=0
virtual StatusCode | getGraph (const std::string &name, TGraph *&) const =0
| Return TGraph with given name. More...
Functions managing shared objects
virtual StatusCode | regShared (const std::string &name, std::unique_ptr< TH1 >, LockedHandle< TH1 > &)=0
| Register shared object of type TH1 and return LockedHandle for that object. More...
virtual StatusCode | regShared (const std::string &name, std::unique_ptr< TH2 >, LockedHandle< TH2 > &)=0
| Register shared object of type TH2 and return LockedHandle for that object. More...
virtual StatusCode | regShared (const std::string &name, std::unique_ptr< TH3 >, LockedHandle< TH3 > &)=0
| Register shared object of type TH3 and return LockedHandle for that object. More...
virtual StatusCode | regShared (const std::string &name, std::unique_ptr< TGraph >, LockedHandle< TGraph > &)=0
| Register shared object of type TGraph and return LockedHandle for that object. More...
virtual StatusCode | getShared (const std::string &name, LockedHandle< TH1 > &) const =0
| Retrieve shared object with given name as TH1 through LockedHandle. More...
virtual StatusCode | getShared (const std::string &name, LockedHandle< TH2 > &) const =0
| Retrieve shared object with given name as TH2 through LockedHandle. More...
virtual StatusCode | getShared (const std::string &name, LockedHandle< TH3 > &) const =0
| Retrieve shared object with given name as TH3 through LockedHandle. More...
virtual StatusCode | getShared (const std::string &name, LockedHandle< TGraph > &) const =0
| Retrieve shared object with given name as TGraph through LockedHandle. More...
Functions that work on any TObject in the THistSvcMT
virtual StatusCode | deReg (const std::string &name)=0
| Deregister object with given name and give up ownership (without deletion!) More...
virtual StatusCode | deReg (TObject *obj)=0
| Deregister obejct identified by TObject* and give up ownership (without deletion!) More...
virtual StatusCode | merge (const std::string &id)=0
| Merge all clones for object with a given id. More...
virtual StatusCode | merge (TObject *)=0
| Merge all clones for given TObject*. More...
virtual bool | exists (const std::string &name) const =0
| Check if object with given name is managed by THistSvcMT. More...
Functions returning lists of all histograms, trees and graphs
virtual std::vector< std::string > | getHists () const =0
virtual std::vector< std::string > | getTrees () const =0
virtual std::vector< std::string > | getGraphs () const =0
virtual StatusCode | getTHists (TDirectory *td, TList &, bool recurse=false) const =0
virtual StatusCode | getTHists (const std::string &name, TList &, bool recurse=false) const =0
virtual StatusCode | getTHists (TDirectory *td, TList &, bool recurse=false, bool reg=false)=0
virtual StatusCode | getTHists (const std::string &name, TList &, bool recurse=false, bool reg=false)=0
virtual StatusCode | getTTrees (TDirectory *td, TList &, bool recurse=false) const =0
virtual StatusCode | getTTrees (const std::string &name, TList &, bool recurse=false) const =0
virtual StatusCode | getTTrees (TDirectory *td, TList &, bool recurse=false, bool reg=false)=0
virtual StatusCode | getTTrees (const std::string &name, TList &, bool recurse=false, bool reg=false)=0
Public Member Functions inherited from IService
| DeclareInterfaceID (IService, 4, 0)
| InterfaceID. More...
virtual StatusCode | sysInitialize ()=0
| Initialize Service. More...
virtual StatusCode | sysStart ()=0
| Start Service. More...
virtual StatusCode | sysStop ()=0
| Stop Service. More...
virtual StatusCode | sysFinalize ()=0
| Finalize Service. More...
virtual StatusCode | sysReinitialize ()=0
| Re-initialize the Service. More...
virtual StatusCode | sysRestart ()=0
| Re-start the Service. More...

## Additional Inherited Members
Public Types inherited from extend_interfaces< INamedInterface, IStateful >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from IService
virtual void | setServiceManager (ISvcManager *)=0

## Detailed Description

Definition at line 23 of file ITHistSvc.h.

## Constructor & Destructor Documentation

## ◆ ~ITHistSvc()

virtual ITHistSvc::~ITHistSvc | ( |  | ) |
| virtual default

virtual destructor

## Member Function Documentation

## ◆ DeclareInterfaceID()

ITHistSvc::DeclareInterfaceID | ( | ITHistSvc | ,
|  | 3 | ,
|  | 0 |
| ) |  |

InterfaceID.

## ◆ deReg() [1/2]

virtual StatusCode ITHistSvc::deReg | ( | const std::string & | name | ) |
| pure virtual

Deregister object with given name and give up ownership (without deletion!)

## ◆ deReg() [2/2]

virtual StatusCode ITHistSvc::deReg | ( | TObject * | obj | ) |
| pure virtual

Deregister obejct identified by TObject* and give up ownership (without deletion!)

## ◆ exists()

virtual bool ITHistSvc::exists | ( | const std::string & | name | ) | const
| pure virtual

Check if object with given name is managed by THistSvcMT.

## ◆ getGraph()

virtual StatusCode ITHistSvc::getGraph | ( | const std::string & | name,
|  | TGraph *& |
| ) |  | const
| pure virtual

Return TGraph with given name.

## ◆ getGraphs()

virtual std::vector<std::string> ITHistSvc::getGraphs | ( |  | ) | const
| pure virtual

## ◆ getHist() [1/3]

virtual StatusCode ITHistSvc::getHist | ( | const std::string & | name,
|  | TH1 *& | ,
|  | size_t | index = `0`
| ) |  | const
| pure virtual

Return histogram with given name as TH1*, THistSvcMT still owns object.

## ◆ getHist() [2/3]

virtual StatusCode ITHistSvc::getHist | ( | const std::string & | name,
|  | TH2 *& | ,
|  | size_t | index = `0`
| ) |  | const
| pure virtual

Return histogram with given name as TH2*, THistSvcMT still owns object.

## ◆ getHist() [3/3]

virtual StatusCode ITHistSvc::getHist | ( | const std::string & | name,
|  | TH3 *& | ,
|  | size_t | index = `0`
| ) |  | const
| pure virtual

Return histogram with given name as TH3*, THistSvcMT still owns object.

## ◆ getHists()

virtual std::vector<std::string> ITHistSvc::getHists | ( |  | ) | const
| pure virtual

## ◆ getShared() [1/4]

virtual StatusCode ITHistSvc::getShared | ( | const std::string & | name,
|  | LockedHandle< TH1 > & |
| ) |  | const
| pure virtual

Retrieve shared object with given name as TH1 through LockedHandle.

## ◆ getShared() [2/4]

virtual StatusCode ITHistSvc::getShared | ( | const std::string & | name,
|  | LockedHandle< TH2 > & |
| ) |  | const
| pure virtual

Retrieve shared object with given name as TH2 through LockedHandle.

## ◆ getShared() [3/4]

virtual StatusCode ITHistSvc::getShared | ( | const std::string & | name,
|  | LockedHandle< TH3 > & |
| ) |  | const
| pure virtual

Retrieve shared object with given name as TH3 through LockedHandle.

## ◆ getShared() [4/4]

virtual StatusCode ITHistSvc::getShared | ( | const std::string & | name,
|  | LockedHandle< TGraph > & |
| ) |  | const
| pure virtual

Retrieve shared object with given name as TGraph through LockedHandle.

## ◆ getTHists() [1/4]

virtual StatusCode ITHistSvc::getTHists | ( | TDirectory * | td,
|  | TList & | ,
|  | bool | recurse = `false`
| ) |  | const
| pure virtual

## ◆ getTHists() [2/4]

virtual StatusCode ITHistSvc::getTHists | ( | const std::string & | name,
|  | TList & | ,
|  | bool | recurse = `false`
| ) |  | const
| pure virtual

## ◆ getTHists() [3/4]

virtual StatusCode ITHistSvc::getTHists | ( | TDirectory * | td,
|  | TList & | ,
|  | bool | recurse = `false`,
|  | bool | reg = `false`
| ) |  |
| pure virtual

## ◆ getTHists() [4/4]

virtual StatusCode ITHistSvc::getTHists | ( | const std::string & | name,
|  | TList & | ,
|  | bool | recurse = `false`,
|  | bool | reg = `false`
| ) |  |
| pure virtual

## ◆ getTree()

virtual StatusCode ITHistSvc::getTree | ( | const std::string & | name,
|  | TTree *& |
| ) |  | const
| pure virtual

Return TTree with given name.

## ◆ getTrees()

virtual std::vector<std::string> ITHistSvc::getTrees | ( |  | ) | const
| pure virtual

## ◆ getTTrees() [1/4]

virtual StatusCode ITHistSvc::getTTrees | ( | TDirectory * | td,
|  | TList & | ,
|  | bool | recurse = `false`
| ) |  | const
| pure virtual

## ◆ getTTrees() [2/4]

virtual StatusCode ITHistSvc::getTTrees | ( | const std::string & | name,
|  | TList & | ,
|  | bool | recurse = `false`
| ) |  | const
| pure virtual

## ◆ getTTrees() [3/4]

virtual StatusCode ITHistSvc::getTTrees | ( | TDirectory * | td,
|  | TList & | ,
|  | bool | recurse = `false`,
|  | bool | reg = `false`
| ) |  |
| pure virtual

## ◆ getTTrees() [4/4]

virtual StatusCode ITHistSvc::getTTrees | ( | const std::string & | name,
|  | TList & | ,
|  | bool | recurse = `false`,
|  | bool | reg = `false`
| ) |  |
| pure virtual

## ◆ merge() [1/2]

virtual StatusCode ITHistSvc::merge | ( | const std::string & | id | ) |
| pure virtual

Merge all clones for object with a given id.

## ◆ merge() [2/2]

virtual StatusCode ITHistSvc::merge | ( | TObject * |  | ) |
| pure virtual

Merge all clones for given TObject*.

## ◆ regGraph() [1/3]

virtual StatusCode ITHistSvc::regGraph | ( | const std::string & | name | ) |
| pure virtual

Register a new TGraph with a given name.

## ◆ regGraph() [2/3]

virtual StatusCode ITHistSvc::regGraph | ( | const std::string & | name,
|  | std::unique_ptr< TGraph > |
| ) |  |
| pure virtual

Register an existing TGraph with a given name and moved unique_ptr.

## ◆ regGraph() [3/3]

virtual StatusCode ITHistSvc::regGraph | ( | const std::string & | name,
|  | TGraph * |
| ) |  |
| pure virtual

Deprecated:
  {Just kept for compatibiltiy to current ATLAS code.

Pleas use std::unique_ptrs instead!} Register a new TGraph with a given name and a raw pointer

## ◆ regHist() [1/4]

virtual StatusCode ITHistSvc::regHist | ( | const std::string & | name | ) |
| pure virtual

Register a new ROOT histogram TH*X with a name.

## ◆ regHist() [2/4]

virtual StatusCode ITHistSvc::regHist | ( | const std::string & | name,
|  | std::unique_ptr< TH1 > | hist
| ) |  |
| pure virtual

Register an existing ROOT histogram TH*X with name and moved unique_ptr.

Parameters

  [in] | name | defines the histogram id/name under which it is recorded
  [in] | hist | transfers ownership of the histogram to the THistSvc

## ◆ regHist() [3/4]

virtual StatusCode ITHistSvc::regHist | ( | const std::string & | name,
|  | std::unique_ptr< TH1 > | hist,
|  | TH1 * | hist_ptr
| ) |  |
| pure virtual

Register an existing ROOT histogram TH*X with name and moved unique_ptr.

Parameters

  [in] | name | defines the histogram id/name under which it is recorded
  [in] | hist | transfers ownership of the histogram to the THistSvc
  [out] | hist_ptr | for compatibility: return raw pointer to managed object to support common usage in Athena

## ◆ regHist() [4/4]

virtual StatusCode ITHistSvc::regHist | ( | const std::string & | name,
|  | TH1 * |
| ) |  |
| pure virtual

Deprecated:
  {Just for compatibility purposes.

Ownership should be clearly managed.} Register an existing ROOT histogram TH*X with name and pointer

## ◆ regShared() [1/4]

virtual StatusCode ITHistSvc::regShared | ( | const std::string & | name,
|  | std::unique_ptr< TH1 > | ,
|  | LockedHandle< TH1 > & |
| ) |  |
| pure virtual

Register shared object of type TH1 and return LockedHandle for that object.

## ◆ regShared() [2/4]

virtual StatusCode ITHistSvc::regShared | ( | const std::string & | name,
|  | std::unique_ptr< TH2 > | ,
|  | LockedHandle< TH2 > & |
| ) |  |
| pure virtual

Register shared object of type TH2 and return LockedHandle for that object.

## ◆ regShared() [3/4]

virtual StatusCode ITHistSvc::regShared | ( | const std::string & | name,
|  | std::unique_ptr< TH3 > | ,
|  | LockedHandle< TH3 > & |
| ) |  |
| pure virtual

Register shared object of type TH3 and return LockedHandle for that object.

## ◆ regShared() [4/4]

virtual StatusCode ITHistSvc::regShared | ( | const std::string & | name,
|  | std::unique_ptr< TGraph > | ,
|  | LockedHandle< TGraph > & |
| ) |  |
| pure virtual

Register shared object of type TGraph and return LockedHandle for that object.

## ◆ regTree() [1/3]

virtual StatusCode ITHistSvc::regTree | ( | const std::string & | name | ) |
| pure virtual

Register a new TTree with a given name.

## ◆ regTree() [2/3]

virtual StatusCode ITHistSvc::regTree | ( | const std::string & | name,
|  | std::unique_ptr< TTree > |
| ) |  |
| pure virtual

Register an existing TTree with a given name and moved unique_ptr.

## ◆ regTree() [3/3]

virtual StatusCode ITHistSvc::regTree | ( | const std::string & | name,
|  | TTree * |
| ) |  |
| pure virtual

Deprecated:
  {Just kept for compatibiltiy to current ATLAS code.

Pleas use std::unique_ptrs instead!} Register a new TTree with a given name and a raw pointer

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/ITHistSvc.h